<%@ page contentType="text/html;charset=gb2312"%>  
<%@ page import="org.softme.webpm.jwiki.*" %>
<%@ page import="org.softme.webpm.jwiki.article.*" %>
<%@ page import="org.softme.webpm.utility.StringUtility" %>

<%
String next = null;
String contents = null;
String title = null;

String docid=request.getParameter("docid") ;
String topic=request.getParameter("topic") ;
String versionid = request.getParameter("version") ;

if(arFactory==null) arFactory=ArticleFactory.getInstance();

Article ar = null;

try{
	if (docid !=null) {
		ar = arFactory.getArticle(Integer.parseInt(docid)) ;
		topic = ar.getTopic();
		title = topic;
		contents = ar.getWikiBody();				
	} else if (versionid !=null){
		// getversion
		ar = arFactory.getVersion(Integer.parseInt(versionid)) ;
		topic = ar.getTopic();
		title = topic + " - 汾" + versionid;
		contents = title + "<hr>" + ar.getWikiBody();
	}else{
		topic = StringUtility.encodeURL2Memory(topic) ;

		if(topic == null || topic.equals("")) {
			topic = "JWIKI ";
		}
		else if(topic.equals("RecentChanges")) {
			next = "recent_changes.jsp";
		}
		else if(topic.equals("TextFormattingRules")) {
			next = "textFormattingRules.jsp";
		}
		else if(topic.equals("WikiSearch")) {
			next = "wiki_search.jsp";
		}
		else if(topic.equals("ActivePage")){
			next="activepage.jsp";
		}
		else if(topic.equals("RecentVisit")){
			next="recentvisit.jsp";
        };
		ar = arFactory.getArticle(topic) ;
		title = topic;
		contents = ar.getWikiBody();
	};

}
catch(ArticleNotFoundException e){
	if(next == null || next.equals("")) {
		next = "wiki_edit.jsp?topic="+StringUtility.URLEncode(topic);
	}
	response.sendRedirect(next);
	return;		// ֹ Null Point 
}
catch(Exception e){

}

%>
