package org.softme.database.datalist;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

/**
 * ResultSetRowMapperʵRowMapperӿڣResultSetʹá
 *
 * һResultSetеֵֶȡŵһַС
 * @author Michael Zeng
 * @version 1.0 September 20, 2002
 */
public class ResultSetRowMapper implements RowMapper
{
    private String[] columns = new String[0];

    /**
     * package캯
     *
     * @param rs ָResultSet
     * @throws SQLException
     */
    ResultSetRowMapper(ResultSet rs) throws SQLException
    {
        this.setColumns(rs);
    }

    /**
     * ȡָResultSetеıѯֶε
     *
     * @return String[] ѯֶε
     */
    public String[] getRowColumns()
    {
        return columns;
    }

    /**
     * ȡResultSetеֵֶŵһַвء
     * ResultSetЧԼ飬е߸顣
     *
     * @param obj ָĲѯ󣬱ResultSet
     * @return String[] ֵֶַ
     * @throws SQLException
     */
    public String[] rowMap(Object obj) throws SQLException
    {
        ResultSet rs = (ResultSet)obj;
        //˽б汻ѯֶ
        if(this.columns == null || this.columns.length == 0)
            this.setColumns(rs);
        String[] values = new String[this.columns.length];
        for (int i = 0; i < this.columns.length; i++)
        {
            values[i] = rs.getString(this.columns[i]);
        }
        return values;
    }

    /**
     * helperȡָResultSetеıѯֶε飬
     * ˽б汻ѯֶΡ
     *
     * @param rs ָResultSet
     * @throws SQLException
     */
    private void setColumns(ResultSet rs) throws SQLException
    {
        ResultSetMetaData rsmd = rs.getMetaData();
        int columnCount = rsmd.getColumnCount();
        this.columns = new String[columnCount];
        for (int i = 0; i < columnCount; i++)
        {
            this.columns[i] = rsmd.getColumnName(i + 1);
        }
     }

}