package org.softme.webpm.info.project;

import java.util.Iterator;

import org.softme.webpm.info.user.UserNotFoundException;

/**
 * <p> Ŀӿ
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public interface Project {	
	
	/**
	 * Project ID
	 */
	public int getProjectID();
	public void setProjectID(int pid);
	
	// Ŀ
	public void setProjectName(String pProjectName);
	public String getProjectName();
		
	// ؼ
	public void setKeywords(String pKeywords);	
	public String getKeywords();
	
	// ȡü
	public String getDescription();	
	public void setDescription(String pDesc);
		
	// : 
	public String getAuthor();	
	public void setAuthor(String pAuthor);
		
	// ԣʱ
	public String getCreateDate();
	public void setCreateDate(String pCreateDate);
		
	// ԣ޸ʱ
	public String getUpdateDate();	
	public void setUpdateDate(String pUpdateDate);
		
	// ñ־
	public void setFlag(int pFlag);	
	public int getFlag();
		
	/**
	 * 浽ݿ
	 */ 
	public boolean save();
	
	/**
	 * ޸Ŀ״̬
	 */ 
	public void modifyFlag();
		
	/**
	 * <p> ĿԱ
	 * @param pMemberName ĿԱû
	 */
	 public boolean addMember(String pMemberName) 
	 			throws UserNotFoundException,
	 			ProjectMemberAlreadyExistsException;	 		
	 
	 /**
	  * <p> ĿԱ
	  * @param pMemberName ĿԱû
	  */
	 public ProjectMember getMember(String pMemberName) throws UserNotFoundException,
	 		MemberNotFoundInProjectException;	 		
	 
	 /**
	  * <p> ɾĿԱ
	  * @param pMemberName ĿԱû
	  */
	 public boolean removeMember(String pMemberName) throws
	 		UserNotFoundException,
	 		MemberNotFoundInProjectException;	 		
	 
	 /**
	  * <p> ĿԱб
	  */
	 public Iterator getAllMembers();	 
}
