package org.softme.webpm.info.user;

import java.util.Iterator;

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * <p> û
 * CopyLeft (l) 2001-2002 by Softme Studio
 * @author BrokenDoor
 * @version 1.2
 */

public abstract class UserFactory {
	private static Object initLock = new Object();
	private static UserFactory uf = null;
	private static String className = "org.softme.webpm.info.user.UserFactoryImp";
	
    /**
	 * <p>ʵû<br>
	 * modify by ,ֻ֤һʵ.
	 */
	public static UserFactory getInstance(){
        if (uf == null) {
            synchronized(initLock) {
                if (uf == null) {
                    try {
                        String classNameProp = WebPMConfig.getProperty("UserFactoryImp.className");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class cls = Class.forName(classNameProp);
                        uf = (UserFactory) cls.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load UserFactory class "
                            + className + ".\n WebPM cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return uf;
    }

	/**
	 * ûȡû
	 * @param pName  û
	 */
	public abstract User getUser( String pName) throws UserNotFoundException ;
	
	/** 
	 * ûIDȡû
	 * @param pID ûID
	 */
	public abstract User getUser( int pID) throws UserNotFoundException ;

    /**
     * עûб
     */
    public abstract Iterator getAllUsers();
	
    /**
     * µĿû
     */
	public abstract User createUser();
	
    /**
     * עû
	 * @param pUser Ҫעû
     */
	public abstract boolean registerUser(User pUser) throws UserHasAlreadyExistsException ;
	
    /**
     * ûб
     */
    public abstract Iterator bestUsers() ;
	
} // class UserManager 's end