package org.softme.webpm.jwiki.tagProcessor;
import org.apache.regexp.RE;
import org.softme.webpm.pub.WebPMConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class CodeTagProcessor implements TagProcessor{

    public CodeTagProcessor() {

    }
    public String process(String pStr){
        CodeTransform transform=new CodeTransform();
        try {

            RE re=new RE("\\[code\\](.+?)\\[\\/code\\]");

            while(re.match(pStr) ){

                String x1=re.getParen(1);
                x1=transform.transform(x1);
                x1="<pre><hr noshade>[myno]"+x1+"[/myno]<hr noshade></pre>";

                pStr=re.subst(pStr,x1,RE.REPLACE_FIRSTONLY ) ;

            }
            return pStr;
        }catch (Exception e) {
        	WebPMConfig.logger.error(e);
            return e.toString();
        }

    }

}