package org.softme.webpm.jwiki.tagProcessor;

/**
 * $RCSfile: LinkProcessor.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

import java.util.ArrayList;
import java.util.List;

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * JWiki ԶӴ
 * @author , BrokenDoor
 * @version 1.2.2
 */

public class LinkProcessor implements TagProcessor{
   
    private ArrayList tags=new ArrayList();
    public LinkProcessor() {
        loadTag();
    }
    public String process(String pStr){
       for(int i=0;i<tags.size() ;i++){
           LinkTagInfo oneTag=(LinkTagInfo)tags.get(i);
           pStr=REReplace.replaceAutoLink(oneTag.linkcode,oneTag.foundcode,oneTag.notfoundcode,pStr) ;
       }
       return pStr;
    }

    private void loadTag(){
		List tagMaps = WebPMConfig.getProperties("JWiki.LinkTag");
        
        LinkTagInfo oneTag=null;
        for(int i=0;i<tagMaps.size();i++){            
        	oneTag = new LinkTagInfo();
            oneTag.linkcode  = WebPMConfig.getProperty("JWiki.LinkTag." + Integer.toString(i) + ".code");
            oneTag.foundcode  = WebPMConfig.getProperty("JWiki.LinkTag." + Integer.toString(i) + ".found");
            oneTag.notfoundcode = WebPMConfig.getProperty("JWiki.LinkTag." + Integer.toString(i) + ".notfound");
            tags.add(oneTag) ;
            Debug.println(oneTag.linkcode ) ;
        }        
    }

	public class LinkTagInfo {
	    public String linkcode=null,foundcode=null,notfoundcode=null;
	    public LinkTagInfo() {
	    }
	}
}