/**
 * $RCSfile: REReplace.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 softme.org (Softme Studio). All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.jwiki.tagProcessor;

import org.apache.regexp.RE;
import org.softme.webpm.jwiki.KeyIndex;
import org.softme.webpm.pub.WebPMConfig;

/**
 * ʽַ滻
 * @author 
 * @version 1.0
 */

public class REReplace
{
    /**
     * replace the inStr with pattern1 & pattern2
    **/
    public static String replace(String pattern1,String pattern2,String inStr){
        try {
            RE re = new RE(pattern1);
            RE re2 = new RE("\\$([0-9])");
            //REReplace.replace(ubbCode,mapStr,inStr);
            //<map ubb-code="\[h1\](.+?)\[\/h1\]" map-to="&lt;h1&gt;$1&lt;/h1&gt;"/>
            String tempPat2=pattern2;
            
            int point=0;
            while(re.match(inStr)){
                while(re2.match(pattern2)){
                    point = Integer.parseInt(re2.getParen(1));
                    //Debug.println(re.getParen(point)) ;
                    pattern2=re2.subst(pattern2,re.getParen(point),RE.REPLACE_FIRSTONLY);

                    //Debug.println("while...2") ;
                }
                //Debug.println("while..1") ;
                inStr = re.subst(inStr,pattern2,RE.REPLACE_FIRSTONLY);
                pattern2 = tempPat2;
            }
            return inStr;
        }
        catch (Exception e) {
            System.out.println(e);
            return e.toString();
        }
    }
  public static String replaceAutoLink(String pattern1,String foundTag,String notFoundTag,String inStr){
      inStr=replaceLink(pattern1,foundTag,notFoundTag,inStr);
      return inStr;
  }

  private static String replaceLink(String pattern1,String foundTag,String notFoundTag,String inStr){
        try {
            RE re = new RE(pattern1);
            RE re2 = new RE("\\$([0-9])");
            KeyIndex index=KeyIndex.getInstance() ;
            //REReplace.replace(ubbCode,mapStr,inStr);
            //<map ubb-code="\[(.+?)\]" map-to="&lt;h1&gt;$1&lt;/h1&gt;"/>
            String tag=null;
            String tempPat1=null;
            //Ϊ˷ַֹԽ
            String endStr=inStr+" ",beginStr="";
            int test=0;
            String hasProcceed="";
            String keyWord=null;
            while(re.match(endStr)){
                    tempPat1=tag;

                    keyWord=re.getParen(1) ;
                    if(keyWord==null) keyWord=re.getParen(2) ;

                   // Debug.println(keyWord) ;
                    beginStr=endStr.substring(0,endStr.indexOf(keyWord)+keyWord.length()+1);
                    endStr=endStr.substring(endStr.indexOf(keyWord)+keyWord.length()+1,endStr.length()) ;
                   if (keyWord!=null){
                       keyWord=keyWord.trim();
                   }
                    if(index.isExist(keyWord)){
                        tag=foundTag;
                    }else{
                        tag=notFoundTag;
                    }
                    while(re2.match(tag)){
                        tag=re2.subst(tag,keyWord,RE.REPLACE_ALL );
                        beginStr = re.subst(beginStr,tag,RE.REPLACE_FIRSTONLY);
                    }
                    hasProcceed=hasProcceed+beginStr;
                    tag=tempPat1;
            }
            return hasProcceed+endStr;
        }
        catch (Exception e) {
        	WebPMConfig.logger.error(e);
//            e.printStackTrace() ;
            return e.toString();
        }
  }
}