package org.softme.webpm.jwiki.tagProcessor;

/**
 * $RCSfile: WebPMTagProcessor.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */
 

import java.util.ArrayList;
import java.util.List;

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * WebPM Ǵ,̳ TagProcessor  WebPM Ǵ
 * @author , BrokenDoor
 * @version 1.2.2
 */

abstract class WebPMTagProcessor implements TagProcessor{

    public WebPMTagProcessor() {
    	
    }
    
    private ArrayList tags=null;
    
    public void setTags(ArrayList pTags){
        this.tags = pTags;
    }
    public String process(String pStr){
       for(int i=0;i<tags.size() ;i++){
           TagInfo oneTag=(TagInfo)tags.get(i);
           pStr=REReplace.replace(oneTag.ubbcode ,oneTag.mapcode,pStr) ;
       }
       return pStr;

    }

    protected ArrayList loadTag(String xmlTag){
        ArrayList tags=new ArrayList();
                
        List tagMaps = WebPMConfig.getProperties(xmlTag);
        TagInfo oneTag=null;
        Debug.println("WebPMTagProcessor:" + tagMaps.iterator().hasNext() ) ;
        for(int i=0; i<tagMaps.size() ;i++){
            oneTag = new TagInfo();
            oneTag.ubbcode = WebPMConfig.getProperty(xmlTag + "." + Integer.toString(i) + ".tag");
            oneTag.mapcode = WebPMConfig.getProperty(xmlTag + "." + Integer.toString(i) + ".value");
            tags.add(oneTag) ;
            Debug.println("WebPMTagProcessor:" + oneTag.ubbcode ) ;
        }
        return tags;
    }

    public class TagInfo {
        public String ubbcode=null;
        public String mapcode=null;
        public TagInfo() {
        }
    }

}