/**
 * $RCSfile: DateTimeUtility.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 softme.org (Softme Studio). All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.utility;

/**
 * ڴ
 * @author 
 * @version 1.0
 */
 
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
public class DateTimeUtility {

  private DateTimeUtility() {
  }
  
  /**
   * ȡǰʱ
   */
  public static String getCurrentDateTime(){
      Calendar calendar = new GregorianCalendar();


      Date trialTime = new Date();

      calendar.setTime(trialTime);

      String sCurrentDateTime=calendar.get(Calendar.YEAR)+"-"+
                              (calendar.get(Calendar.MONTH )+1) +"-"+
                              calendar.get(Calendar.DATE) +" "+
                              calendar.get(Calendar.HOUR_OF_DAY)+":"+
                              calendar.get(Calendar.MINUTE)+":"+
                              calendar.get(Calendar.SECOND);
      return sCurrentDateTime;
  }
  
  /**
   * ȡyyyy-mm-ddʽַ
   * @param pDateTime תǰַ
   */  
  public static String getYMD(String pDateTime){
      try{
          java.text.SimpleDateFormat format=new java.text.SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
          java.util.Date unFormat=format.parse(pDateTime) ;
          Calendar calendar=new GregorianCalendar();
          calendar.setTime(unFormat) ;
          int year=calendar.get(Calendar.YEAR);
          int month=calendar.get(Calendar.MONTH)+1;
          int date=calendar.get(Calendar.DATE);
          String sYear=null,sMonth=null,sDate=null;
          if(year<10) sYear="0"+year;
          else sYear=Integer.toString(year) ;
          if(month<10) sMonth="0"+month;
          else sMonth=Integer.toString(month) ;
          if(date<10) sDate="0"+date;
          else sDate=Integer.toString(date) ;
          return sYear+"-"+sMonth+"-"+sDate;

      }catch(Exception e){
          e.printStackTrace() ;
          return e.toString() ;
      }
  }

}