package org.softme.webpm.test.pub;

import junit.framework.TestCase;

import org.softme.webpm.pub.WebPMConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPMConfigTest extends TestCase{

  public WebPMConfigTest(String name) {
      super(name);
  }
  public static void main(String[] args) {

      junit.textui.TestRunner.run(WebPMConfigTest.class) ;

  }
  public void testConfigParam(){

      final String DBUser="webpm";
      final String DBDriver="org.gjt.mm.mysql.Driver";
      final String ArticleFactoryImp="org.softme.webpm.jwiki.article.ArticleFactoryImp";
      final String TagProcessorFactoryImp="org.softme.webpm.jwiki.tagProcessor.TagProcessorFactoryImp";
      	  
	  assertEquals(DBUser,WebPMConfig.getProperty("DB.UserName"));      
      assertNotNull(WebPMConfig.getProperty("DB.URL"));
      assertEquals(DBDriver,WebPMConfig.getProperty("DB.Driver") );

      assertEquals(ArticleFactoryImp,WebPMConfig.getProperty("JWiki.ClassName.ArticleFactoryImp"));
      assertEquals(TagProcessorFactoryImp,WebPMConfig.getProperty("JWiki.ClassName.TagProcessorFactoryImp"));
  }
}