package org.softme.webpm.info.user;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.DateTimeUtility;
import org.softme.webpm.utility.StringUtility;

/**
 * Title:        JavaBean û
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      webpm
 * @author ̤
 * @version 1.0
 */

public class UserImp implements User {
	protected int gID = -1, gFlag = 0 ;
	protected String gUserName,gPassword,gQuestion,gAnswer,
			gEmail,gAddress,gPhone,gSex,
			gBirthday,gCreateDate,gUpdateDate,gMemo;      

	/**
	 * ûID
	 */	
	public int getUserID() {
		return this.gID;
	}
	public void setUserID(int pid) {
		this.gID = pid;
	}

	/**
	 * û
	 */	
	public void setUserName(String pUserName) {
		this.gUserName=pUserName;
	}
	public String getUserName() {
		return this.gUserName;
	}

	/**
	 * û
	 */	
	public void setPassword(String pPassword) {
		this.gPassword = pPassword;
	}
	public String getPassword() {
		 return this.gPassword;
	}

	/**
	 * 
	 */ 
	public void setQuestion(String pQuestion) {
		 this.gQuestion = pQuestion;
	}
	public String getQuestion() {
		 return this.gQuestion;
	}

	/**
	 * 
	 */ 
	public void setAnswer(String pAnswer) {
		 this.gAnswer = pAnswer;
	}
	public String getAnswer() {
		return this.gAnswer;
	}

	/**
	 * Email
	 */ 
	public void setEmail(String pEmail) {
		this.gEmail = pEmail;
	}
	public String getEmail() {
		return this.gEmail;
	}

	/**
	 * ַ
	 */
	public void setAddress(String pAddress) {
		this.gAddress= pAddress;
	}
	public String getAddress() {
		return this.gAddress;
	}

	/** 
	 * 绰
	 */
	public void setPhone(String pPhone) {
		this.gPhone=pPhone;
	}
	public String getPhone() {
		return this.gPhone;
	};

	/** 
	 * Ա M -  / W - Ů
	 */
	public void setSex(String pSex) {
		this.gSex = pSex;
	}
	public String getSex() {
		return this.gSex;
	}

	/**
	 * 
	 */
	public void setBirthday(String pBirthday) {
		this.gBirthday=pBirthday;
	};
	public String getBirthday() {
		return this.gBirthday;
	}

	/** 
	 * 
	 */
	public void setMemo(String pMemo) {
		this.gMemo = pMemo;
	}
	public String getMemo() {
		return this.gMemo;
	}

	/** 
	 * ʱ
	 */
	public String getCreateDate(){
		return this.gCreateDate;
	}
	public void setCreateDate(String pCreateDate) {
		this.gCreateDate = pCreateDate;
	}
	
	/** 
	 * ޸ʱ
	 */
	public String getUpdateDate(){
		return this.gUpdateDate;
	}
	public void setUpdateDate(String pUpdateDate){
		this.gUpdateDate = pUpdateDate;	
	}

	/** 
	 * ־
	 */
	public void setFlag(int pFlag) {
		this.gFlag= pFlag;
	}
	public int getFlag() {
		 return this.gFlag;
	}

	/**
	 * 캯
	 */
	void User() { }

	/**
	 * 浽ݿ
	 */
	public boolean save(){
		boolean rtn;
		if (this.gID<0){
			rtn = this.insertToDB();
		} else {
			rtn = this.modifyToDB();
		}
		return false;		
	}

	private boolean insertToDB() {
        String INSERT_USER = "INSERT INTO t_webpm_user (fusername, fpassword, fquestion, fanswer, femail, fsex, fbirthday, fphone, faddress, fmemo, fcreatedate, fupdatedate, fflag) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?) ";
        
        this.gCreateDate =DateTimeUtility.getCurrentDateTime() ;
        this.gUpdateDate =gCreateDate;
        
        PreparedStatement pstmt=null;
        Connection conn=null;
		boolean rtn = false;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(INSERT_USER) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gUserName)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gPassword));
            pstmt.setString(3,StringUtility.encodeMemory2DB(gQuestion)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gAnswer));
            pstmt.setString(5,StringUtility.encodeMemory2DB(gEmail)) ;
            pstmt.setString(6,gSex) ;
            pstmt.setString(7,StringUtility.encodeMemory2DB(gBirthday)) ;
            pstmt.setString(8,StringUtility.encodeMemory2DB(gPhone)) ;
            pstmt.setString(9,StringUtility.encodeMemory2DB(gAddress)) ;
            pstmt.setString(10,StringUtility.encodeMemory2DB(gMemo)) ;
            pstmt.setString(11,gCreateDate) ;
            pstmt.setString(12,gUpdateDate) ;
            pstmt.setInt(13,gFlag) ;
            pstmt.executeUpdate() ;
            
	    	rtn = true;

        }catch(SQLException e){
            WebPMConfig.logger.error(e);
            rtn = false;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
		return rtn;
    }

    private boolean modifyToDB(){
        String UPDATE_USER="UPDATE t_webpm_user SET fusername=?,fpassword=?,fquestion=?,fanswer=?,femail=?,fsex=?,fbirthday=?,fphone=?,faddress=?,fmemo=?,fcreatedate=?,fupdatedate=?,fflag=? WHERE fid=?";
        
        gUpdateDate=DateTimeUtility.getCurrentDateTime();        
        PreparedStatement pstmt=null;
        Connection conn=null;
        boolean rtn = true;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_USER) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gUserName)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gPassword));
            pstmt.setString(3,StringUtility.encodeMemory2DB(gQuestion)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gAnswer));
            pstmt.setString(5,StringUtility.encodeMemory2DB(gEmail)) ;
            pstmt.setString(6,gSex) ;
            pstmt.setString(7,gBirthday) ;
            pstmt.setString(8,StringUtility.encodeMemory2DB(gPhone)) ;
            pstmt.setString(9,StringUtility.encodeMemory2DB(gAddress)) ;
            pstmt.setString(10,StringUtility.encodeMemory2DB(gMemo)) ;
            pstmt.setString(11,gCreateDate) ;
            pstmt.setString(12,gUpdateDate) ;
            pstmt.setInt(13,gFlag) ;
            pstmt.setInt(14,gID) ;
            pstmt.executeUpdate() ;

        }catch(SQLException e){
            WebPMConfig.logger.error(e);
            rtn = false;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }

        return rtn;
    }

    private boolean modifygFlag(){
        String UPDATE_USER = "UPDATE t_webpm_user SET fgFlag=? WHERE fid=?";
        PreparedStatement pstmt=null;
        Connection conn=null;
        boolean rtn = false;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_USER) ;
            pstmt.setInt(1 ,gFlag) ;
            pstmt.setInt(2,gID) ;
            pstmt.executeUpdate() ;
            rtn = true;
        }catch(SQLException e){
            WebPMConfig.logger.error(e);
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
        return rtn;
    }
	
	/**
     * <p>ıûı־
     * @param aFlag ־ֵ
     */
    public boolean changeFlag(int aFlag){
    	this.setFlag(aFlag);
    	return this.modifygFlag();
    };
    	
}
