package org.softme.webpm.jwiki.query;
import java.util.Iterator;
import java.util.LinkedList;

import org.softme.webpm.jwiki.article.VisitInfo;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class RecentVisitorQueue {
    private LinkedList queue=new LinkedList();
    private final int MAX_NUMBER=20;
    private RecentVisitorQueue() {
    }
    public void add(VisitInfo visitor){
        if(queue.size() >=MAX_NUMBER){
            queue.removeLast() ;
        }
        queue.addFirst(visitor) ;
    }

    public Iterator iterator(){
        return queue.iterator() ;
    }

}