package org.softme.webpm.jwiki.tagProcessor;

import java.util.ArrayList;

import org.apache.regexp.RE;
import org.softme.webpm.pub.WebPMConfig;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class NoProcessor implements NoWikiTagProcessor{
    private ArrayList codeArray=new ArrayList();
    private String gPattern="\\[no\\](.+?)\\[\\/no\\]",gTempTag="{code}do_not_process_jwiki_tag_area{/code}";
    private String gMakeUpPattern="\\{code\\}do_not_process_jwiki_tag_area\\{\\/code\\}";
    public NoProcessor() {
    }
    public NoProcessor(String pPattern,String pMakeUpPattern,String pTempTag){
        gMakeUpPattern=pMakeUpPattern;
        gPattern=pPattern;
        gTempTag=pTempTag;
    }
    public String process(String pStr){
        return pStr;
    }
    public  String split(String pStr){
        try{
        String codeArea=gTempTag;
        RE re=new RE(gPattern);


            while(re.match(pStr) ){

                String x1=re.getParen(1);

                codeArray.add(x1) ;

                pStr=re.subst(pStr,codeArea,RE.REPLACE_FIRSTONLY ) ;

            }
            return pStr;
        }catch(Exception e){
        	WebPMConfig.logger.error(e);
//            e.printStackTrace() ;
            return null;
        }
    }
    public  String makeUp(String pStr){
        try{
            RE re=new RE(gMakeUpPattern);
            int i=0;
            RE re2=new RE("  "); 
            	//codeǵԭԽеո滻ʱӰɫ,:<font color=xx>
            while(re.match(pStr) ){

                    String codeString=(String)codeArray.get(i);
                    codeString=re2.subst(codeString,"&nbsp;&nbsp;",RE.REPLACE_ALL ) ;
                    pStr=re.subst(pStr,codeString,RE.REPLACE_FIRSTONLY ) ;
                    i++;                 
		
            }
            codeArray.clear() ;
            return pStr;
        }catch(Exception e){
        	WebPMConfig.logger.error(e);
            //e.printStackTrace() ;
            return null;
        }

    }
}