package org.softme.webpm.jwiki.tagProcessor;

import org.apache.regexp.RE;
import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserFactory;
import org.softme.webpm.info.user.UserNotFoundException;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:      Softme Studio
 * @author 
 * @version 1.2
 */

public class UserTagProcessor implements TagProcessor{
    private UserFactory uf = UserFactory.getInstance() ;
    public UserTagProcessor() {
    }
    public String process(String pStr){
        CodeTransform transform=new CodeTransform();
        try {

            RE re=new RE("\\[user=(.+?)\\]");

            while(re.match(pStr) ){
                String userInfo="<hr>";
                String x1=re.getParen(1);
                try{

                    User existingUser=uf.getUser(x1) ;
                    userInfo=userInfo+"û:"+existingUser.getUserName()+
                                    "&nbsp;&nbsp;&nbsp;Ա:"+existingUser.getSex()+
                                    "&nbsp;&nbsp;&nbsp;Email:<a href=\"mailto:"+existingUser.getEmail()+"\">"+existingUser.getEmail()+"</a>"+
                                    "&nbsp;&nbsp;&nbsp;绰:"+existingUser.getPhone()+
                                    "<br>ַ:"+existingUser.getAddress()+
                                    "<br>:"+existingUser.getMemo()+
                                    "<br><a href='../user/user_article.jsp?username="+existingUser.getUserName()+"'></a>";

                }catch(UserNotFoundException e){
                    userInfo=userInfo+"û";
                }
                x1=userInfo+"<hr>";
                userInfo="";
                //Ӳǩ
   //             x1="[myno]"+x1+"[/myno]";

                pStr=re.subst(pStr,x1,RE.REPLACE_FIRSTONLY ) ;

            }
            return pStr;
        }catch (Exception e) {
            e.printStackTrace() ;
            System.out.println(e);
            return e.toString();
        }

    }
}