/**
 * $RCSfile: DBConnection.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.pub;

/**
 * ݿӴӳش
 * 
 * @author BrokenDoor
 * @version 1.2.3
 */

import java.sql.Connection;
import java.sql.PreparedStatement;
//import java.sql.DriverManager;

public class DBConnection {
	
	private static ConnectionManager connPool = null;
	
    private DBConnection() {
    }
    /* õһݿ */
    public static Connection newInstance() throws java.sql.SQLException{
        try{
//            Class.forName(WebPMConfig.getProperty("DB.Driver")) ;
//            Connection conn=DriverManager.getConnection(WebPMConfig.getProperty("DB.URL"),
//                                                        WebPMConfig.getProperty("DB.Password")) ;
//  			                                              WebPMConfig.getProperty("DB.UserName"),
			connPool = ConnectionManager.getInstance();			
			Connection conn = connPool.getConnection();

            return conn;
        }
        catch(java.lang.ClassNotFoundException ex){
            throw new java.sql.SQLException ("Can't get connection:"+ex.toString());
        }
        catch(java.sql.SQLException sqlex){
            throw sqlex;
        }
		catch(Exception e){
		    throw new java.sql.SQLException ("Can't get connection:"+ e.toString());        
		}
    }
  public static void closeConnection(PreparedStatement pstmt,Connection conn){
      try{
      	pstmt.close() ;
//      	conn.close() ;
		connPool.freeConncetion(conn);
      }
      catch(Exception e){
      	//Debug.println(e.toString());
      	WebPMConfig.logger.error(e);
      }
  }
}