package org.softme.webpm.servlet.file;

import java.io.File;
import java.io.IOException;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.info.user.User;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 *  <p>
 *
 *  Title: </p> DeleteUpload<p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     ymruan(ymruan@163.net)
 *@created    2002228
 *@version    1.0
 */

public class DeleteFile extends HttpServlet {
    private final static String CONTENT_TYPE = "text/html; charset=GBK";

    //Initialize global variables

    /**
     *  Description of the Method
     *
     *@exception  ServletException  Description of the Exception
     */
    public void init() throws ServletException {
    }

    //Process the HTTP Get request

    /**
     *  Description of the Method
     *
     *@param  request               Description of the Parameter
     *@param  response              Description of the Parameter
     *@exception  ServletException  Description of the Exception
     *@exception  IOException       Description of the Exception
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doPost(request, response);
    }

    //Process the HTTP Post request

    /**
     *  Description of the Method
     *
     *@param  request               Description of the Parameter
     *@param  response              Description of the Parameter
     *@exception  ServletException  Description of the Exception
     *@exception  IOException       Description of the Exception
     */
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String[] selectedFiles = request.getParameterValues("selectedFile");
        String gPageRoot = WebPMConfig.getProperty("Site.DefaultRoot");
        
        String userName;
        HttpSession session = request.getSession();
        if (session.getAttribute("user") != null) {
            userName = ((User) session.getAttribute("user")).getUserName().toLowerCase();
        } else {
            userName = "public";
        }
        String baseDir = "doc/users/";
        if (WebPMConfig.getProperty("UploadFile.BaseDir") != null) {
            if (WebPMConfig.getProperty("UploadFile.BaseDir").trim().length() != 0) {
                baseDir = WebPMConfig.getProperty("UploadFile.BaseDir");
            }
        }
        
		ServletContext servletContext = getServletContext();
						
        String filePath = servletContext.getRealPath(baseDir) + "/" + userName + "/";
        
        Debug.println("filepath:" + filePath);
        
         for (int i = 0; i < selectedFiles.length; i++) {
            if (!selectedFiles[i].equals("-1")) {
                try {
                    File file = new File(filePath + selectedFiles[i]);
					Debug.println("Deleting file:" + filePath + selectedFiles[i]);
                    file.delete();
                } catch (Exception e) {
                    System.out.println("Error in Servlet DeleteFile" + e.toString());
                    response.sendRedirect( gPageRoot + "file/file_delete_error.jsp");
                }
            }
        }
        response.sendRedirect( gPageRoot + "file/file_upload.jsp");
    }

    //Clean up resources

    /**
     *  Description of the Method
     */
    public void destroy() {
        System.out.println("servlet destory.......");
    }
}
