package org.softme.webpm.utility;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class XMLUtility {
    private static org.apache.xerces.parsers.DOMParser parser =
        new org.apache.xerces.parsers.DOMParser();
    private XMLUtility() {
    }
    public static Document xml2Document(String XMLFilePath){
        try{
            parser.parse(XMLFilePath) ;
            Document document =parser.getDocument();
            return document;
        }catch(Exception err){
            System.out.println(err);
            return null;
        }
    }
  public static String getNodeAttr(Element pElement,String pElementName,String pAttrName){
      NodeList nodelist=pElement.getElementsByTagName(pElementName) ;
      Node node=nodelist.item(0) ;
      NamedNodeMap attrs=node.getAttributes() ;
      Node attrNode=attrs.getNamedItem(pAttrName) ;
      return attrNode.getNodeValue();
  }
}