package org.softme.webpm.test.jwiki;
import junit.framework.TestCase;

import org.softme.webpm.jwiki.tagProcessor.TagProcessorFactory;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class TagProcessorFactoryTest extends TestCase{
    private TagProcessorFactory tagFactory=TagProcessorFactory.getInstance();
    public TagProcessorFactoryTest(String name) {
        super(name);
    }
    public static void main(String[] args) {
       //TestSuite tagSuite=new TestSuite(TagProcessorFactoryTest.class);
        junit.textui.TestRunner.run(TagProcessorFactoryTest.class) ;
    }
    public void testWikiTagParse(){
        String s="aa[no][ss][/no]bb";
        s=tagFactory.processTags(s) ;
        assertEquals("aa[ss]bb",s);
    }

}